/*	$Id: flt_rounds.c,v 1.3 2002/08/13 12:57:49 tsubai Exp $	*/

#include <sys/types.h>
#include <ieeefp.h>
#include <float.h>

static const u_char map[] = {
	1,	/* round to nearest */
	0,	/* round to zero */
	2,	/* round to positive infinity */
	3	/* round to negative infinity */
};

int
__flt_rounds()
{
#ifdef _SOFT_FLOAT
	return map[fpgetround()];
#else
	u_int64_t fpscr;

	__asm ("mffs %0" : "=f"(fpscr));
	return map[fpscr & 0x03];
#endif
}
