/*	$Id: trap.h,v 1.3 2002/06/10 12:42:14 tsubai Exp $	*/

#include <powerpc/trap.h>

/* Implementation specific traps */

#define EXC_SOFTEMU	0x1000	/* Software emulation */
#define EXC_ITLBMISS	0x1100	/* Instruction TLB miss */
#define EXC_DTLBMISS	0x1200	/* Data TLB miss */
#define EXC_ITLBERR	0x1300	/* Instruction TLB error */
#define EXC_DTLBERR	0x1400	/* Data TLB error */
#define EXC_DBREAK	0x1c00	/* Data break point */
#define EXC_IBREAK	0x1d00	/* Instruction break point */
#define EXC_PBREAK	0x1e00	/* Peripheral break point */
#define EXC_NMDP	0x1f00	/* Non maskable development port */
